'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _constants = require('../constants');

var _buildMarkdown = require('../buildMarkdown');

var _buildMarkdown2 = _interopRequireDefault(_buildMarkdown);

var _MarkdownStyle = require('./MarkdownStyle');

var _MarkdownStyle2 = _interopRequireDefault(_MarkdownStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DocPanel = function (_React$Component) {
    _inherits(DocPanel, _React$Component);

    function DocPanel() {
        var _ref;

        _classCallCheck(this, DocPanel);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        // $FlowIgnore
        var _this = _possibleConstructorReturn(this, (_ref = DocPanel.__proto__ || Object.getPrototypeOf(DocPanel)).call.apply(_ref, [this].concat(_toConsumableArray(args))));

        _this.state = {
            docgenInfos: []
        };
        _this.buildDocHtml = _this.buildDocHtml.bind(_this);
        // $FlowIgnore
        _this.onLoadDocData = _this.onLoadDocData.bind(_this);
        return _this;
    }

    _createClass(DocPanel, [{
        key: 'onLoadDocData',
        value: function onLoadDocData(docgenInfos) {
            this.setState({ docgenInfos: docgenInfos || [] });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.channel.on(_constants.event.LoadDocData, this.onLoadDocData);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.props.channel.removeListener(_constants.event.LoadDocData, this.onLoadDocData);
        }
    }, {
        key: 'buildDocHtml',
        value: function buildDocHtml() {
            var md = this.state.docgenInfos.map(function (d) {
                return (0, _buildMarkdown2.default)(d);
            }).join('\n\n\n');

            return (0, _marked2.default)(md);
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.state.docgenInfos.length === 0) {
                return null;
            }

            return React.createElement(
                'div',
                null,
                React.createElement(_MarkdownStyle2.default, null),
                React.createElement('div', {
                    style: { boxSizing: 'border-box', padding: 10, width: '100%' },
                    className: 'markdown-body',
                    dangerouslySetInnerHTML: { __html: this.buildDocHtml() }
                })
            );
        }
    }]);

    return DocPanel;
}(React.Component);

exports.default = DocPanel;
//# sourceMappingURL=DocPanel.js.map